%define	lvmversion	2.03.23
%define	dmversion	1.02.196
%define	_usrsbindir	%{_prefix}/sbin
%define	_sbindir	/sbin
%define	dmmajor		1.02
%define	cmdmajor	2.02
%define	appmajor	2.2

%{?optflags_lto:%global optflags_lto %optflags_lto -ffat-lto-objects}
%define _disable_ld_no_undefined 1

%define	dmlibname	%mklibname devmapper %dmmajor
%define	dmdevelname	%mklibname devmapper -d
%define	event_libname	%mklibname devmapper-event %dmmajor
%define	event_develname	%mklibname devmapper-event -d
%define cmdlibname	%mklibname lvm2cmd %cmdmajor
%define cmddevelname	%mklibname lvm2cmd -d

%define	build_dmeventd 1

%define	_udevdir	/lib/udev/rules.d

%{?_with_dmeventd: %{expand: %%global build_dmeventd 1}}
%{?_without_dmeventd: %{expand: %%global build_dmeventd 0}}

%if %build_dmeventd
%define dm_req	%{event_libname}
%define dm_req_d	%{event_develname}
%else
%define dm_req	%{dmlibname}
%define dm_req_d	%{dmdevelname}
%endif

Summary:	Logical Volume Manager administration tools
Name:		lvm2
Version:	%{lvmversion}
Release:	%mkrel 1
Source0:	ftp://sources.redhat.com/pub/lvm2/LVM2.%{lvmversion}.tgz

Source3: lvm2-monitor.init
Source5: blk-availability.init
Source6: lvm2-lvmpolld.init

Patch3:		lvm2-2.02.187-alternatives.patch
License:	GPLv2 and LGPL2.1
Group:		System/Kernel and hardware
URL:		http://sources.redhat.com/lvm2/
BuildConflicts:	device-mapper-devel < %{dmversion}
BuildRequires:	readline-devel
BuildRequires:	ncurses-devel
BuildRequires:	sed
Conflicts:	lvm
Conflicts:	lvm1
BuildRequires:	glibc-static-devel
%if %build_dmeventd
# install plugins as well
Requires:	%{cmdlibname} = %{lvmversion}-%{release}
%endif
Requires:	%{dm_req} >= %{dmversion}

%description
LVM includes all of the support for handling read/write operations on
physical volumes (hard disks, RAID-Systems, magneto optical, etc.,
multiple devices (MD), see mdadm(8) or even loop devices, see losetup(8)),
creating volume groups (kind of virtual disks) from one or more physical
volumes and creating one or more logical volumes (kind of logical partitions)
in volume groups.

%package -n	%{cmdlibname}
Summary:	LVM2 command line library
Group:		System/Kernel and hardware
Requires:	%{dm_req} >= %{dmversion}
# Avoid devel deps on library due to autoreq picking these plugins up as devel libs
%define _requires_exceptions devel\\(libdevmapper
%define _provides_exceptions devel\\(libdevmapper

%description -n	%{cmdlibname}
The lvm2 command line library allows building programs that manage
lvm devices without invoking a separate program.

%package -n	%{cmddevelname}
Summary:	Development files for LVM2 command line library
Group:		System/Kernel and hardware
Requires:	%{cmdlibname} = %{lvmversion}-%{release}
Requires:	%{dm_req_d} = %{dmversion}-%{release}
Provides:	liblvm2cmd-devel = %{lvmversion}-%{release}
Obsoletes:	%{mklibname lvm2cmd %cmdmajor -d}

%description -n	%{cmddevelname}
The lvm2 command line library allows building programs that manage
lvm devices without invoking a separate program.
This package contains the header files for building with lvm2cmd

%package -n	dmsetup
Summary:	Device mapper setup tool
Version:	%{dmversion}
Group:		System/Kernel and hardware
Provides:	device-mapper = %{dmversion}-%{release}
%if %{build_dmeventd}
Provides:	dmeventd = %{dmversion}-%{release}
%endif
Requires:	%{dm_req} = %{dmversion}-%{release}
BuildRequires:	udev-devel
Requires:	udev
Requires(pre):	rpm-helper
Requires: lib64aio1

%description -n	dmsetup
Dmsetup manages logical devices that use the device-mapper driver.  
Devices are created by loading a table that specifies a target for
each sector (512 bytes) in the logical device.

%package -n	%{dmlibname}
Summary:	Device mapper library
Version:	%{dmversion}
Group:		System/Kernel and hardware
Provides:   libdevmapper.so.1.02()(64bit)

%description -n	%{dmlibname}
The device-mapper driver enables the definition of new block
devices composed of ranges of sectors of existing devices.  This
can be used to define disk partitions - or logical volumes.

This package contains the shared libraries required for running
programs which use device-mapper.

%package -n	%{dmdevelname}
Summary:	Device mapper development library
Version:	%{dmversion}
Group:		Development/Libraries
Provides:	device-mapper-devel = %{dmversion}-%{release}
Provides:	libdevmapper-devel = %{dmversion}-%{release}
Requires:	%{dmlibname} = %{dmversion}-%{release}
Requires:	pkgconfig
Conflicts:	device-mapper-devel < %{dmversion}-%{release}
Obsoletes:	%{mklibname devmapper %dmmajor -d}
Provides:   devel(libdevmapper(64bit))

%description -n	%{dmdevelname}
The device-mapper driver enables the definition of new block
devices composed of ranges of sectors of existing devices.  This
can be used to define disk partitions - or logical volumes.

This package contains the header files and development libraries
for building programs which use device-mapper.

%if %{build_dmeventd}

%package -n	%{event_libname}
Summary:	Device mapper event library
Version:	%{dmversion}
Group:		System/Kernel and hardware
Provides:	device-mapper-event = %{dmversion}-%{release}
Provides:	libdevmapper-event = %{dmversion}-%{release}
Provides:   libdevmapper-event.so.1.02()(64bit)
Requires:	%{dmlibname} >= %{dmversion}

%description -n	%{event_libname}
The device-mapper-event library allows monitoring of active mapped devices.

This package contains the shared libraries required for running
programs which use device-mapper-event.

%package -n	%{event_develname}
Summary:	Device mapper event development library
Version:	%{dmversion}
Group:		Development/Libraries
Provides:	device-mapper-event-devel = %{dmversion}-%{release}
Provides:	libdevmapper-event-devel = %{dmversion}-%{release}
Requires:	%{event_libname} = %{dmversion}-%{release}
Requires:	%{dmdevelname} = %{dmversion}-%{release}
Requires:	pkgconfig
Conflicts:	device-mapper-event-devel < %{dmversion}-%{release}
Obsoletes:	%{mklibname devmapper-event %dmmajor -d}

%description -n	%{event_develname}
The device-mapper-event library allows monitoring of active mapped devices.

This package contains the header files and development libraries
for building programs which use device-mapper-event.
%endif

%prep
%setup -q -n LVM2.%{lvmversion}
%autopatch -p1

%build

%if %{build_dmeventd}
%define _disable_ld_as_needed 1
%endif
%define common_configure_parameters --with-default-dm-run-dir=/run --with-default-run-dir=/run/lvm --with-default-pid-dir=/run --with-default-locking-dir=/run/lock/lvm --with-user=`id -un` --with-group=`id -gn` --disable-selinux --with-device-uid=0 --with-device-gid=6 --with-device-mode=0660 %{?configure_lvmdbusd}
export MODPROBE_CMD=/sbin/modprobe

%configure2_5x %{common_configure_parameters} \
	--disable-static_link --enable-readline \
	--enable-fsadm --enable-pkgconfig \
	--with-usrlibdir=%{_libdir} --libdir=/%{_libdir} \
	--enable-cmdlib \
	--enable-dependency-tracking \
%if %{build_dmeventd}
	--enable-dmeventd \
	--with-dmeventd-path=/sbin/dmeventd \
%endif
	--enable-udev_sync --enable-udev_rules \
	--with-udevdir=%{_udevdir}
%make_build

%install
grep /bin/python3 daemons/lvmdbusd/lvmdbusd || perl -pi -e 's@^(#!/usr/bin/python)@${1}3@' daemons/lvmdbusd/lvmdb.py daemons/lvmdbusd/lvmdbusd
%make_install
make install_system_dirs DESTDIR=$RPM_BUILD_ROOT

install -d %{buildroot}/etc/lvm/archive
install -d %{buildroot}/etc/lvm/backup
install -d %{buildroot}/etc/lvm/cache
touch %{buildroot}/etc/lvm/cache/.cache


#compatibility links
ln %{buildroot}/%{_sbindir}/lvm %{buildroot}/%{_sbindir}/lvm2

#hack permissions of libs
chmod u+w %{buildroot}/%{_libdir}/*.so.* %{buildroot}/%{_sbindir}/*


#hack trick strip_and_check_elf_files
export LD_LIBRARY_PATH=%{buildroot}/%{_libdir}:${LD_LIBRARY_PATH}
chmod 0755 %{buildroot}/usr/lib64/device-mapper/*.so

mkdir -p %{buildroot}/lib64
ln -fs /usr/lib64/libdevmapper.so.1.02 %{buildroot}/lib64/libdevmapper.so.1.02
                           
### lvm2-monitor init script

install -d %{buildroot}/%{_initrddir}
install -m 0755 %SOURCE3 %{buildroot}/%{_initrddir}/lvm2-monitor
install -m 0755 %SOURCE5 %{buildroot}/%{_initrddir}/blk-availability

%pre
if [ -L /sbin/lvm -a -L /etc/alternatives/lvm ]; then
	update-alternatives --remove lvm /sbin/lvm2
fi


%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/blkdeactivate
%attr(755,root,root) %{_sbindir}/fsadm
%attr(755,root,root) %{_sbindir}/lvm
%attr(755,root,root) %{_sbindir}/lvm2
%attr(755,root,root) %{_sbindir}/lvchange
%attr(755,root,root) %{_sbindir}/lvmconfig
%attr(755,root,root) %{_sbindir}/lvconvert
%attr(755,root,root) %{_sbindir}/lvcreate
%attr(755,root,root) %{_sbindir}/lvdisplay
%attr(755,root,root) %{_sbindir}/lvmdump
%attr(755,root,root) %{_sbindir}/lvextend
%attr(755,root,root) %{_sbindir}/lvmdevices
%attr(755,root,root) %{_sbindir}/lvmdiskscan
%attr(755,root,root) %{_sbindir}/lvm_import_vdo
%attr(755,root,root) %{_sbindir}/lvmsadc
%attr(755,root,root) %{_sbindir}/lvmsar
%attr(755,root,root) %{_sbindir}/lvreduce
%attr(755,root,root) %{_sbindir}/lvremove
%attr(755,root,root) %{_sbindir}/lvrename
%attr(755,root,root) %{_sbindir}/lvresize
%attr(755,root,root) %{_sbindir}/lvs
%attr(755,root,root) %{_sbindir}/lvscan
%attr(755,root,root) %{_sbindir}/pvchange
%attr(755,root,root) %{_sbindir}/pvck
%attr(755,root,root) %{_sbindir}/pvcreate
%attr(755,root,root) %{_sbindir}/pvdisplay
%attr(755,root,root) %{_sbindir}/pvmove
%attr(755,root,root) %{_sbindir}/pvremove
%attr(755,root,root) %{_sbindir}/pvresize
%attr(755,root,root) %{_sbindir}/pvs
%attr(755,root,root) %{_sbindir}/pvscan
%attr(755,root,root) %{_sbindir}/vgcfgbackup
%attr(755,root,root) %{_sbindir}/vgcfgrestore
%attr(755,root,root) %{_sbindir}/vgchange
%attr(755,root,root) %{_sbindir}/vgck
%attr(755,root,root) %{_sbindir}/vgconvert
%attr(755,root,root) %{_sbindir}/vgcreate
%attr(755,root,root) %{_sbindir}/vgdisplay
%attr(755,root,root) %{_sbindir}/vgexport
%attr(755,root,root) %{_sbindir}/vgextend
%attr(755,root,root) %{_sbindir}/vgimport
%attr(755,root,root) %{_sbindir}/vgimportclone
%attr(755,root,root) %{_sbindir}/vgimportdevices

%attr(755,root,root) %{_sbindir}/vgmerge
%attr(755,root,root) %{_sbindir}/vgmknodes
%attr(755,root,root) %{_sbindir}/vgreduce
%attr(755,root,root) %{_sbindir}/vgremove
%attr(755,root,root) %{_sbindir}/vgrename
%attr(755,root,root) %{_sbindir}/vgs
%attr(755,root,root) %{_sbindir}/vgscan
%attr(755,root,root) %{_sbindir}/vgsplit
%attr(755, -, -) %{_libexecdir}/lvresize_fs_helper
%config(noreplace) %attr(755,root,root) %{_initrddir}/lvm2-monitor
%config(noreplace) %attr(755,root,root) %{_initrddir}/blk-availability
%dir %{_sysconfdir}/lvm
%config(noreplace) %{_sysconfdir}/lvm/lvm.conf
%config(noreplace) %{_sysconfdir}/lvm/lvmlocal.conf
%dir %{_sysconfdir}/lvm/profile
%config(noreplace) %{_sysconfdir}/lvm/profile/command_profile_template.profile
%config(noreplace) %{_sysconfdir}/lvm/profile/metadata_profile_template.profile
%config(noreplace) %{_sysconfdir}/lvm/profile/thin-generic.profile
%config(noreplace) %{_sysconfdir}/lvm/profile/thin-performance.profile
%config(noreplace) %{_sysconfdir}/lvm/profile/cache-mq.profile
%config(noreplace) %{_sysconfdir}/lvm/profile/cache-smq.profile
%config(noreplace) %{_sysconfdir}/lvm/profile/lvmdbusd.profile
%config(noreplace) %{_sysconfdir}/lvm/profile/vdo-small.profile
%attr(700,root,root) %dir %{_sysconfdir}/lvm/archive
%attr(700,root,root) %dir %{_sysconfdir}/lvm/backup
%attr(700,root,root) %dir %{_sysconfdir}/lvm/cache
%attr(600,root,root) %ghost %{_sysconfdir}/lvm/cache/.cache
%{_mandir}/man5/*
%{_mandir}/man7/*
%{_mandir}/man8/*
%{_udevdir}/11-dm-lvm.rules
%{_udevdir}/69-dm-lvm.rules

%files -n %{cmdlibname}
%defattr(644,root,root,755)
%{_libdir}/liblvm2cmd.so.*
%if %{build_dmeventd}
%dir /%{_libdir}/device-mapper
%{_libdir}/device-mapper/libdevmapper-event-lvm2mirror.so
%{_libdir}/device-mapper/libdevmapper-event-lvm2raid.so
%{_libdir}/device-mapper/libdevmapper-event-lvm2snapshot.so
%{_libdir}/device-mapper/libdevmapper-event-lvm2thin.so
%{_libdir}/device-mapper/libdevmapper-event-lvm2vdo.so
%{_libdir}/libdevmapper-event-lvm2.so.*
%{_libdir}/libdevmapper-event-lvm2mirror.so
%{_libdir}/libdevmapper-event-lvm2raid.so
%{_libdir}/libdevmapper-event-lvm2snapshot.so
%{_libdir}/libdevmapper-event-lvm2thin.so
%endif

%files -n %{cmddevelname}
%defattr(644,root,root,755)
%{_includedir}/lvm2cmd.h
%attr(755,root,root) %{_libdir}/liblvm2cmd.so


%files -n dmsetup
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/dmsetup
%attr(755,root,root) %{_sbindir}/dmstats
%if %{build_dmeventd}
%attr(755,root,root) %{_sbindir}/dmeventd
%endif
%{_mandir}/man8/dmsetup.8*
%{_udevdir}/10-dm.rules
%{_udevdir}/13-dm-disk.rules
%{_udevdir}/95-dm-notify.rules

%files -n %{dmlibname}
%defattr(755,root,root)
%{_libdir}/libdevmapper.so.*
/lib64/libdevmapper.so.*

%files -n %{dmdevelname}
%defattr(644,root,root,755)
%{_libdir}/libdevmapper.so
%{_includedir}/libdevmapper.h
%{_libdir}/pkgconfig/devmapper.pc

%if %{build_dmeventd}
%defattr(755,root,root)
%files -n %{event_libname}
%{_libdir}/libdevmapper-event.so.*

%files -n %{event_develname}
%defattr(644,root,root,755)
%{_includedir}/libdevmapper-event.h
%{_libdir}/libdevmapper-event.so
%{_libdir}/libdevmapper-event-lvm2.so
%{_libdir}/libdevmapper-event-lvm2vdo.so
%{_libdir}/pkgconfig/devmapper-event.pc
%endif

%changelog
* Thu Jan 11 2024 yodelu - 2.03.23-1pclos2024
- update version

* Sun Jun 25 2023 tex - 2.02.187-3pclos2023
- try to avoid pulling in devel packages
- I do not know shit about this package ok

* Tue Dec 20 2022 tex - 2.02.187-2pclos2022
- rebuild against updates

* Thu Dec 05 2019 onkelho <oh.quait at gmail.com> - 2.02.187-1pclos2019
- update last stable-2.02.187
- includes update dm 1.02.166

* Mon Jun 10 2019 tex - 2.02.168-2pclos2019
- rebuild against updates

* Thu Jul 13 2017 bb2 <bb2> - 2.02.168-1pclos2017
- new version for new kernel

